Download it now!
Bug 44856 - Calc: font on screen looks corrupted
Summary: Calc: font on screen looks corrupted
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
3.5.0 Beta2
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Caolán McNamara
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-01-17 04:24 UTC by sasha.libreoffice
Modified: 2012-01-25 01:12 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
cells with corrupted font (51.84 KB, application/vnd.oasis.opendocument.spreadsheet)
2012-01-17 04:24 UTC, sasha.libreoffice
Details
separate screenshot from Fedora 64 bit LibO 3.5.0 beta 2 (109.45 KB, image/png)
2012-01-17 04:34 UTC, sasha.libreoffice
Details
this seems to work (1.17 KB, patch)
2012-01-19 05:35 UTC, David Tardon
Details
screenshot of calc fonts in master of 24 jan 2012 (116.22 KB, image/png)
2012-01-24 04:00 UTC, sasha.libreoffice
Details
how it looks for me (63.89 KB, image/png)
2012-01-24 04:58 UTC, Caolán McNamara
Details

Note You need to log in before you can comment on or make changes to this bug.
Description sasha.libreoffice 2012-01-17 04:24:02 UTC
Created attachment 55671 [details]
cells with corrupted font

in Calc when cell content rotated on 90 degree and set Italic, then characters look wrong (as if each character is slightly rotated)
in attachment are cells with different font and screenshot of it on my comp.
produced on Fedora 64 bit in LibO 3.5.0 beta 2
ps: not all font are corrupted, approximately one half
Comment 1 Caolán McNamara 2012-01-17 04:29:27 UTC
can you attach a screenshot of bustage as well ?
Comment 2 sasha.libreoffice 2012-01-17 04:34:56 UTC
Created attachment 55672 [details]
separate screenshot from Fedora 64 bit LibO 3.5.0 beta 2
Comment 3 Caolán McNamara 2012-01-17 05:28:33 UTC
must be artificial italic + rotated glyphs, i.e. vcl/generic/gdi/salgdi3.cxx X11SalGraphics::DrawServerFontLayout
Comment 4 David Tardon 2012-01-19 05:35:53 UTC
Created attachment 55779 [details]
this seems to work

If I understand cairo transformations correctly, they are "applied" in reverse order. And we need to shear the glyphs before rotating them. The nGlyphRotation stuff would most probably need adjustment too.
Comment 5 Caolán McNamara 2012-01-23 04:18:39 UTC
caolanm->dtardon: Thanks, can you give this a once over for sanity ?

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8f23e9813daae808aa2a81250b5e414dc57a3394

I've updated qadevOOo/testdocs/vertical-testcase.odt and it looks sane for vertical CJK text using artificial italic
Comment 6 David Tardon 2012-01-23 04:27:18 UTC
sure, looks sane
Comment 8 sasha.libreoffice 2012-01-24 04:00:34 UTC
Created attachment 56070 [details]
screenshot of calc fonts in master of 24 jan 2012

Sorry for interrupt, but only 3 fonts fixed, another remains corrupted
Comment 9 Caolán McNamara 2012-01-24 04:58:24 UTC
Created attachment 56073 [details]
how it looks for me

This is my screenshot, which looks ok, the git commits from help->about for me and this is 832cd0c-5cd8d9c-9eed775-f061262-4dba2d1. Can you paste in your help->about build-id as well.
Comment 10 sasha.libreoffice 2012-01-24 06:24:13 UTC
Build ID: 1ccb93b-9eed775-f061262-libreoffice-3-5 branch-point
Comment 11 Caolán McNamara 2012-01-24 06:37:52 UTC
git show 1ccb93b

commit 1ccb93b138b3d29b7ee497cdfb8a7cec5acb01cd
Date:   Fri Jan 20 10:15:07 2012 +0100

and

git show 8f23e98

commit 8f23e9813daae808aa2a81250b5e414dc57a3394
Date:   Mon Jan 23 12:15:44 2012 +0000

hmm, I'm hoping your pull and build happened before my commit, can you pull and build again ?
Comment 12 sasha.libreoffice 2012-01-24 06:51:56 UTC
thanks for explanation!
I am new to git, and wrongly used fetch instead of pull.
Compiling ...
Comment 13 sasha.libreoffice 2012-01-24 08:33:30 UTC
While compiling it complains on this:

ERROR: Duplicate node/prop '/VCL/DefaultFonts/bn'!
make[1]: *** [/usr/src/libre-master/core/workdir/unxlngx6.pro/XcuDataTarget/officecfg/registry/data/org/openoffice/VCL.xcu] Error 10

I have found in file
/usr/src/libre-master/core/officecfg/registry/data/org/openoffice/VCL.xcu

this line twice:
<node oor:name="bn" oor:op="replace">
Comment 14 sasha.libreoffice 2012-01-25 01:12:57 UTC
It works!
Thanks for fix and for explanation how use git properly